/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/






static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern0 (x1, E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern0 (x1, E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x1, E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern2 (); /* [-1, 2] */
}

static int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return pattern2 (); /* [-1, 2] */
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern4 (x1, E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern4 (x1, E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern4 (x1, E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 0;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 1;

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 2;

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              res = pattern3 (x3, E_QImode);
              if (res >= 0)
                return res + 7; /* [7, 9] */
              return -1;

            case E_HImode:
              res = pattern3 (x3, E_HImode);
              if (res >= 0)
                return res + 10; /* [10, 12] */
              return -1;

            case E_SImode:
              res = pattern3 (x3, E_SImode);
              if (res >= 0)
                return res + 13; /* [13, 15] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern5 (x3);
          if (res >= 0)
            return res + 16; /* [16, 24] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      return pattern5 (x1); /* [-1, 8] */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          res = pattern7 (x1, E_QImode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_HImode:
          res = pattern7 (x1, E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        case E_SImode:
          res = pattern7 (x1, E_SImode);
          if (res >= 0)
            return res + 15; /* [15, 17] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      return pattern8 (x3); /* [-1, 17] */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern9 (x3, E_QImode) != 0)
                return -1;
              return 18;

            case E_HImode:
              if (pattern9 (x3, E_HImode) != 0)
                return -1;
              return 19;

            case E_SImode:
              if (pattern9 (x3, E_SImode) != 0)
                return -1;
              return 20;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 21; /* [21, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !shift_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

static int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          return pattern5 (x3); /* [-1, 8] */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              res = pattern11 (x3, E_QImode);
              if (res >= 0)
                return res + 9; /* [9, 11] */
              return -1;

            case E_HImode:
              res = pattern11 (x3, E_HImode);
              if (res >= 0)
                return res + 12; /* [12, 14] */
              return -1;

            case E_SImode:
              res = pattern11 (x3, E_SImode);
              if (res >= 0)
                return res + 15; /* [15, 17] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern12 (x3, E_QImode) != 0)
                return -1;
              return 18;

            case E_HImode:
              if (pattern12 (x3, E_HImode) != 0)
                return -1;
              return 19;

            case E_SImode:
              if (pattern12 (x3, E_SImode) != 0)
                return -1;
              return 20;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 21; /* [21, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 6)
    return -1;
  return 0;
}

static int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

static int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_ubyte_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern21 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_ubyte_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern21 (); /* [-1, 2] */
}

static int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 14
          || GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case RETURN:
      return 1;

    default:
      return -1;
    }
}

static int
pattern27 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return pattern27 (); /* [-1, 2] */
}

static int
pattern29 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern32 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x6;
      if (pru_cmp_operator (operands[0], E_VOIDmode))
        {
          switch (pattern25 (x2))
            {
            case 0:
              return 591; /* cbranchqi4_unsigned */

            case 1:
              return 592; /* cbranchhi4_unsigned */

            case 2:
              return 593; /* cbranchsi4_unsigned */

            default:
              break;
            }
        }
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTRACT)
        return -1;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XEXP (x7, 2);
      operands[1] = x11;
      x12 = XEXP (x3, 0);
      operands[2] = x12;
      switch (GET_CODE (x6))
        {
        case EQ:
          switch (GET_MODE (x7))
            {
            case E_QImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 597; /* cbranch_qbbx_eqqiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 599; /* cbranch_qbbx_eqqihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 601; /* cbranch_qbbx_eqqisiqi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 603; /* cbranch_qbbx_eqhiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 605; /* cbranch_qbbx_eqhihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 607; /* cbranch_qbbx_eqhisiqi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 609; /* cbranch_qbbx_eqsiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 611; /* cbranch_qbbx_eqsihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 613; /* cbranch_qbbx_eqsisiqi4 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 615; /* cbranch_qbbx_eqqiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 617; /* cbranch_qbbx_eqqihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 619; /* cbranch_qbbx_eqqisihi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 621; /* cbranch_qbbx_eqhiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 623; /* cbranch_qbbx_eqhihihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 625; /* cbranch_qbbx_eqhisihi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 651; /* cbranch_qbbx_const_eqhi */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 627; /* cbranch_qbbx_eqsiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 629; /* cbranch_qbbx_eqsihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 631; /* cbranch_qbbx_eqsisihi4 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 633; /* cbranch_qbbx_eqqiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 635; /* cbranch_qbbx_eqqihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 637; /* cbranch_qbbx_eqqisisi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 639; /* cbranch_qbbx_eqhiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 641; /* cbranch_qbbx_eqhihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 643; /* cbranch_qbbx_eqhisisi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 645; /* cbranch_qbbx_eqsiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 647; /* cbranch_qbbx_eqsihisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 649; /* cbranch_qbbx_eqsisisi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 653; /* cbranch_qbbx_const_eqsi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 655; /* cbranch_qbbx_const_eqdi */

            default:
              return -1;
            }

        case NE:
          switch (GET_MODE (x7))
            {
            case E_QImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 598; /* cbranch_qbbx_neqiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 600; /* cbranch_qbbx_neqihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 602; /* cbranch_qbbx_neqisiqi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 604; /* cbranch_qbbx_nehiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 606; /* cbranch_qbbx_nehihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 608; /* cbranch_qbbx_nehisiqi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 610; /* cbranch_qbbx_nesiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 612; /* cbranch_qbbx_nesihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 614; /* cbranch_qbbx_nesisiqi4 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 616; /* cbranch_qbbx_neqiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 618; /* cbranch_qbbx_neqihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 620; /* cbranch_qbbx_neqisihi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 622; /* cbranch_qbbx_nehiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 624; /* cbranch_qbbx_nehihihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 626; /* cbranch_qbbx_nehisihi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 652; /* cbranch_qbbx_const_nehi */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 628; /* cbranch_qbbx_nesiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 630; /* cbranch_qbbx_nesihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 632; /* cbranch_qbbx_nesisihi4 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern32 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 634; /* cbranch_qbbx_neqiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 636; /* cbranch_qbbx_neqihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 638; /* cbranch_qbbx_neqisisi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 640; /* cbranch_qbbx_nehiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 642; /* cbranch_qbbx_nehihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 644; /* cbranch_qbbx_nehisisi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 646; /* cbranch_qbbx_nesiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 648; /* cbranch_qbbx_nesihisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 650; /* cbranch_qbbx_nesisisi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 654; /* cbranch_qbbx_const_nesi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 656; /* cbranch_qbbx_const_nedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      operands[0] = x6;
      if (!pru_signed_cmp_operator (operands[0], E_VOIDmode))
        return -1;
      switch (pattern25 (x2))
        {
        case 0:
          return 594; /* cbranchqi4_signed */

        case 1:
          return 595; /* cbranchhi4_signed */

        case 2:
          return 596; /* cbranchsi4_signed */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 2)
    return -1;
  switch (XINT (x2, 1))
    {
    case 0:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  switch (pattern28 (x2, E_QImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 145; /* pru_lmbd_implqiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 149; /* pru_lmbd_implqiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 151; /* pru_lmbd_implqiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 153; /* pru_lmbd_implqihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 154; /* pru_lmbd_implqihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 155; /* pru_lmbd_implqihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 156; /* pru_lmbd_implqisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 157; /* pru_lmbd_implqisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 158; /* pru_lmbd_implqisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                case E_HImode:
                  switch (pattern28 (x2, E_HImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 159; /* pru_lmbd_implhiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 160; /* pru_lmbd_implhiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 161; /* pru_lmbd_implhiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 162; /* pru_lmbd_implhihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 164; /* pru_lmbd_implhihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 168; /* pru_lmbd_implhihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 170; /* pru_lmbd_implhisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 171; /* pru_lmbd_implhisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 172; /* pru_lmbd_implhisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                case E_SImode:
                  switch (pattern28 (x2, E_SImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 173; /* pru_lmbd_implsiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 174; /* pru_lmbd_implsiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 175; /* pru_lmbd_implsiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 176; /* pru_lmbd_implsihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 177; /* pru_lmbd_implsihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 178; /* pru_lmbd_implsihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 179; /* pru_lmbd_implsisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 181; /* pru_lmbd_implsisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 183; /* pru_lmbd_implsisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern29 (x2, E_QImode) != 0)
                    return -1;
                  return 147; /* pru_lmbd_implqiqiqi__z_z1_noz2 */

                case E_HImode:
                  if (pattern29 (x2, E_HImode) != 0)
                    return -1;
                  return 166; /* pru_lmbd_implhihihi__z_z1_noz2 */

                case E_SImode:
                  if (pattern29 (x2, E_SImode) != 0)
                    return -1;
                  return 185; /* pru_lmbd_implsisisi__z_z1_noz2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern30 (x2, E_QImode) != 0)
                    return -1;
                  return 146; /* pru_lmbd_implqiqiqi__noz_z1_z2 */

                case E_HImode:
                  if (pattern30 (x2, E_HImode) != 0)
                    return -1;
                  return 165; /* pru_lmbd_implhihihi__noz_z1_z2 */

                case E_SImode:
                  if (pattern30 (x2, E_SImode) != 0)
                    return -1;
                  return 184; /* pru_lmbd_implsisisi__noz_z1_z2 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern31 (x2, E_QImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 148; /* pru_lmbd_implqiqiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 150; /* pru_lmbd_implqiqihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 152; /* pru_lmbd_implqiqisi__z_noz1_z2 */

                case E_HImode:
                  if (pattern31 (x2, E_HImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 163; /* pru_lmbd_implhihiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 167; /* pru_lmbd_implhihihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 169; /* pru_lmbd_implhihisi__z_noz1_z2 */

                case E_SImode:
                  if (pattern31 (x2, E_SImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 180; /* pru_lmbd_implsisiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 182; /* pru_lmbd_implsisihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 186; /* pru_lmbd_implsisisi__z_noz1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x6 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 128)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x3))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !reg_or_ubyte_operand (operands[0], E_HImode))
            return -1;
          return 661; /* pruloophi */

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !reg_or_ubyte_operand (operands[0], E_SImode))
            return -1;
          return 662; /* pruloopsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      if (const_fillbytes_operand (operands[2], E_HImode))
        return 40; /* pru_ior_fillbyteshi */
      if (single_one_operand (operands[2], E_HImode))
        return 229; /* setbit_hihi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 351; /* ior_implhihihi__noz_z1_z2 */

    case 1:
      if (const_fillbytes_operand (operands[2], E_SImode))
        return 41; /* pru_ior_fillbytessi */
      if (single_one_operand (operands[2], E_SImode))
        return 234; /* setbit_sisi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 461; /* ior_implsisisi__noz_z1_z2 */

    case 2:
      if (const_fillbytes_operand (operands[2], E_DImode))
        return 42; /* pru_ior_fillbytesdi */
      if (!reg_or_ubyte_operand (operands[2], E_DImode))
        return -1;
      return 577; /* pru_iordi3 */

    case 3:
      if (single_one_operand (operands[2], E_QImode))
        return 224; /* setbit_qiqi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 241; /* ior_implqiqiqi__noz_z1_z2 */

    case 4:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 242; /* ior_implqiqiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 258; /* ior_implqiqihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 268; /* ior_implqiqisi__z_noz1_z2 */

    case 5:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 338; /* ior_implhihiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 352; /* ior_implhihihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 368; /* ior_implhihisi__z_noz1_z2 */

    case 6:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 438; /* ior_implsisiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 448; /* ior_implsisihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 462; /* ior_implsisisi__z_noz1_z2 */

    case 7:
      if (single_one_operand (operands[2], E_QImode))
        return 223; /* setbit_qiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 240; /* ior_implqiqiqi__z_z1_noz2 */

    case 8:
      if (single_one_operand (operands[2], E_QImode))
        return 225; /* setbit_qihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 278; /* ior_implqihiqi__z_z1_noz2 */

    case 9:
      if (single_one_operand (operands[2], E_QImode))
        return 226; /* setbit_qisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 298; /* ior_implqisiqi__z_z1_noz2 */

    case 10:
      if (single_one_operand (operands[2], E_HImode))
        return 227; /* setbit_hiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 323; /* ior_implhiqihi__z_z1_noz2 */

    case 11:
      if (single_one_operand (operands[2], E_HImode))
        return 228; /* setbit_hihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 350; /* ior_implhihihi__z_z1_noz2 */

    case 12:
      if (single_one_operand (operands[2], E_HImode))
        return 230; /* setbit_hisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 383; /* ior_implhisihi__z_z1_noz2 */

    case 13:
      if (single_one_operand (operands[2], E_SImode))
        return 231; /* setbit_siqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 408; /* ior_implsiqisi__z_z1_noz2 */

    case 14:
      if (single_one_operand (operands[2], E_SImode))
        return 232; /* setbit_sihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 428; /* ior_implsihisi__z_z1_noz2 */

    case 15:
      if (single_one_operand (operands[2], E_SImode))
        return 233; /* setbit_sisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 460; /* ior_implsisisi__z_z1_noz2 */

    case 16:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 239; /* ior_implqiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 257; /* ior_implqiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 267; /* ior_implqiqisi__z_z1_z2 */

    case 17:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 277; /* ior_implqihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 286; /* ior_implqihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 291; /* ior_implqihisi__z_z1_z2 */

    case 18:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 297; /* ior_implqisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 306; /* ior_implqisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 311; /* ior_implqisisi__z_z1_z2 */

    case 19:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 316; /* ior_implhiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 322; /* ior_implhiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 331; /* ior_implhiqisi__z_z1_z2 */

    case 20:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 337; /* ior_implhihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 349; /* ior_implhihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 367; /* ior_implhihisi__z_z1_z2 */

    case 21:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 376; /* ior_implhisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 382; /* ior_implhisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 391; /* ior_implhisisi__z_z1_z2 */

    case 22:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 396; /* ior_implsiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 401; /* ior_implsiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 407; /* ior_implsiqisi__z_z1_z2 */

    case 23:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 416; /* ior_implsihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 421; /* ior_implsihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 427; /* ior_implsihisi__z_z1_z2 */

    case 24:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 437; /* ior_implsisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 447; /* ior_implsisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 459; /* ior_implsisisi__z_z1_z2 */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      if (const_zerobytes_operand (operands[2], E_HImode))
        return 43; /* pru_and_zerobyteshi */
      if (single_zero_operand (operands[2], E_HImode))
        return 217; /* clearbit_hihi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 347; /* and_implhihihi__noz_z1_z2 */

    case 1:
      if (const_zerobytes_operand (operands[2], E_SImode))
        return 44; /* pru_and_zerobytessi */
      if (single_zero_operand (operands[2], E_SImode))
        return 222; /* clearbit_sisi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 457; /* and_implsisisi__noz_z1_z2 */

    case 2:
      if (const_zerobytes_operand (operands[2], E_DImode))
        return 45; /* pru_and_zerobytesdi */
      if (!reg_or_ubyte_operand (operands[2], E_DImode))
        return -1;
      return 576; /* pru_anddi3 */

    case 3:
      if (single_zero_operand (operands[2], E_QImode))
        return 212; /* clearbit_qiqi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 237; /* and_implqiqiqi__noz_z1_z2 */

    case 4:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 238; /* and_implqiqiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 256; /* and_implqiqihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 266; /* and_implqiqisi__z_noz1_z2 */

    case 5:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 336; /* and_implhihiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 348; /* and_implhihihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 366; /* and_implhihisi__z_noz1_z2 */

    case 6:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 436; /* and_implsisiqi__z_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 446; /* and_implsisihi__z_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 458; /* and_implsisisi__z_noz1_z2 */

    case 7:
      if (single_zero_operand (operands[2], E_QImode))
        return 211; /* clearbit_qiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 236; /* and_implqiqiqi__z_z1_noz2 */

    case 8:
      if (single_zero_operand (operands[2], E_QImode))
        return 213; /* clearbit_qihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 276; /* and_implqihiqi__z_z1_noz2 */

    case 9:
      if (single_zero_operand (operands[2], E_QImode))
        return 214; /* clearbit_qisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 296; /* and_implqisiqi__z_z1_noz2 */

    case 10:
      if (single_zero_operand (operands[2], E_HImode))
        return 215; /* clearbit_hiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 321; /* and_implhiqihi__z_z1_noz2 */

    case 11:
      if (single_zero_operand (operands[2], E_HImode))
        return 216; /* clearbit_hihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 346; /* and_implhihihi__z_z1_noz2 */

    case 12:
      if (single_zero_operand (operands[2], E_HImode))
        return 218; /* clearbit_hisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 381; /* and_implhisihi__z_z1_noz2 */

    case 13:
      if (single_zero_operand (operands[2], E_SImode))
        return 219; /* clearbit_siqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 406; /* and_implsiqisi__z_z1_noz2 */

    case 14:
      if (single_zero_operand (operands[2], E_SImode))
        return 220; /* clearbit_sihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 426; /* and_implsihisi__z_z1_noz2 */

    case 15:
      if (single_zero_operand (operands[2], E_SImode))
        return 221; /* clearbit_sisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 456; /* and_implsisisi__z_z1_noz2 */

    case 16:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 235; /* and_implqiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 255; /* and_implqiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 265; /* and_implqiqisi__z_z1_z2 */

    case 17:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 275; /* and_implqihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 285; /* and_implqihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 290; /* and_implqihisi__z_z1_z2 */

    case 18:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 295; /* and_implqisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 305; /* and_implqisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 310; /* and_implqisisi__z_z1_z2 */

    case 19:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 315; /* and_implhiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 320; /* and_implhiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 330; /* and_implhiqisi__z_z1_z2 */

    case 20:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 335; /* and_implhihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 345; /* and_implhihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 365; /* and_implhihisi__z_z1_z2 */

    case 21:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 375; /* and_implhisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 380; /* and_implhisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 390; /* and_implhisisi__z_z1_z2 */

    case 22:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 395; /* and_implsiqiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 400; /* and_implsiqihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 405; /* and_implsiqisi__z_z1_z2 */

    case 23:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 415; /* and_implsihiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 420; /* and_implsihihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 425; /* and_implsihisi__z_z1_z2 */

    case 24:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 435; /* and_implsisiqi__z_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 445; /* and_implsisihi__z_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 455; /* and_implsisisi__z_z1_z2 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern9 (x3, E_DImode) != 0)
                return -1;
              return 38; /* adddi3 */

            case E_QImode:
              if (pattern18 (x3, E_QImode) != 0)
                return -1;
              return 51; /* add_implqiqiqi__noz_z1_z2 */

            case E_HImode:
              if (pattern18 (x3, E_HImode) != 0)
                return -1;
              return 73; /* add_implhihihi__noz_z1_z2 */

            case E_SImode:
              if (pattern18 (x3, E_SImode) != 0)
                return -1;
              return 95; /* add_implsisisi__noz_z1_z2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1 (x3))
            {
            case 0:
              if (nonmemory_operand (operands[2], E_QImode))
                return 52; /* add_implqiqiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 54; /* add_implqiqihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 56; /* add_implqiqisi__z_noz1_z2 */

            case 1:
              if (nonmemory_operand (operands[2], E_QImode))
                return 70; /* add_implhihiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 74; /* add_implhihihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 76; /* add_implhihisi__z_noz1_z2 */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode))
                return 90; /* add_implsisiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 92; /* add_implsisihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 96; /* add_implsisisi__z_noz1_z2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern5 (x3))
            {
            case 0:
              if (nonmemory_operand (operands[2], E_QImode))
                return 49; /* add_implqiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 53; /* add_implqiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 55; /* add_implqiqisi__z_z1_z2 */

            case 1:
              if (nonmemory_operand (operands[2], E_QImode))
                return 57; /* add_implqihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 59; /* add_implqihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 60; /* add_implqihisi__z_z1_z2 */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode))
                return 61; /* add_implqisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 63; /* add_implqisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 64; /* add_implqisisi__z_z1_z2 */

            case 3:
              if (nonmemory_operand (operands[2], E_QImode))
                return 65; /* add_implhiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 66; /* add_implhiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 68; /* add_implhiqisi__z_z1_z2 */

            case 4:
              if (nonmemory_operand (operands[2], E_QImode))
                return 69; /* add_implhihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 71; /* add_implhihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 75; /* add_implhihisi__z_z1_z2 */

            case 5:
              if (nonmemory_operand (operands[2], E_QImode))
                return 77; /* add_implhisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 78; /* add_implhisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 80; /* add_implhisisi__z_z1_z2 */

            case 6:
              if (nonmemory_operand (operands[2], E_QImode))
                return 81; /* add_implsiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 82; /* add_implsiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 83; /* add_implsiqisi__z_z1_z2 */

            case 7:
              if (nonmemory_operand (operands[2], E_QImode))
                return 85; /* add_implsihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 86; /* add_implsihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 87; /* add_implsihisi__z_z1_z2 */

            case 8:
              if (nonmemory_operand (operands[2], E_QImode))
                return 89; /* add_implsisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 91; /* add_implsisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 93; /* add_implsisisi__z_z1_z2 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern19 (x3, E_QImode))
                {
                case 0:
                  return 50; /* add_implqiqiqi__z_z1_noz2 */

                case 1:
                  return 58; /* add_implqihiqi__z_z1_noz2 */

                case 2:
                  return 62; /* add_implqisiqi__z_z1_noz2 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern19 (x3, E_HImode))
                {
                case 0:
                  return 67; /* add_implhiqihi__z_z1_noz2 */

                case 1:
                  return 72; /* add_implhihihi__z_z1_noz2 */

                case 2:
                  return 79; /* add_implhisihi__z_z1_noz2 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern19 (x3, E_SImode))
                {
                case 0:
                  return 84; /* add_implsiqisi__z_z1_noz2 */

                case 1:
                  return 88; /* add_implsihisi__z_z1_noz2 */

                case 2:
                  return 94; /* add_implsisisi__z_z1_noz2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern20 (x3, E_DImode) != 0)
                return -1;
              return 39; /* subdi3 */

            case E_QImode:
              if (pattern20 (x3, E_QImode) != 0)
                return -1;
              return 99; /* sub_implqiqiqi__noz_z1_z2 */

            case E_HImode:
              if (pattern20 (x3, E_HImode) != 0)
                return -1;
              return 121; /* sub_implhihihi__noz_z1_z2 */

            case E_SImode:
              if (pattern20 (x3, E_SImode) != 0)
                return -1;
              return 143; /* sub_implsisisi__noz_z1_z2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern22 (x3, E_QImode))
                {
                case 0:
                  return 100; /* sub_implqiqiqi__z_noz1_z2 */

                case 1:
                  return 102; /* sub_implqiqihi__z_noz1_z2 */

                case 2:
                  return 104; /* sub_implqiqisi__z_noz1_z2 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern22 (x3, E_HImode))
                {
                case 0:
                  return 118; /* sub_implhihiqi__z_noz1_z2 */

                case 1:
                  return 122; /* sub_implhihihi__z_noz1_z2 */

                case 2:
                  return 124; /* sub_implhihisi__z_noz1_z2 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern22 (x3, E_SImode))
                {
                case 0:
                  return 138; /* sub_implsisiqi__z_noz1_z2 */

                case 1:
                  return 140; /* sub_implsisihi__z_noz1_z2 */

                case 2:
                  return 144; /* sub_implsisisi__z_noz1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern23 (x3, E_QImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 97; /* sub_implqiqiqi__z_z1_z2 */

                    case 1:
                      return 101; /* sub_implqiqihi__z_z1_z2 */

                    case 2:
                      return 103; /* sub_implqiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 105; /* sub_implqihiqi__z_z1_z2 */

                    case 1:
                      return 107; /* sub_implqihihi__z_z1_z2 */

                    case 2:
                      return 108; /* sub_implqihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern21 ())
                {
                case 0:
                  return 109; /* sub_implqisiqi__z_z1_z2 */

                case 1:
                  return 111; /* sub_implqisihi__z_z1_z2 */

                case 2:
                  return 112; /* sub_implqisisi__z_z1_z2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (pattern23 (x3, E_HImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 113; /* sub_implhiqiqi__z_z1_z2 */

                    case 1:
                      return 114; /* sub_implhiqihi__z_z1_z2 */

                    case 2:
                      return 116; /* sub_implhiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 117; /* sub_implhihiqi__z_z1_z2 */

                    case 1:
                      return 119; /* sub_implhihihi__z_z1_z2 */

                    case 2:
                      return 123; /* sub_implhihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern21 ())
                {
                case 0:
                  return 125; /* sub_implhisiqi__z_z1_z2 */

                case 1:
                  return 126; /* sub_implhisihi__z_z1_z2 */

                case 2:
                  return 128; /* sub_implhisisi__z_z1_z2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (pattern23 (x3, E_SImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 129; /* sub_implsiqiqi__z_z1_z2 */

                    case 1:
                      return 130; /* sub_implsiqihi__z_z1_z2 */

                    case 2:
                      return 131; /* sub_implsiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern21 ())
                    {
                    case 0:
                      return 133; /* sub_implsihiqi__z_z1_z2 */

                    case 1:
                      return 134; /* sub_implsihihi__z_z1_z2 */

                    case 2:
                      return 135; /* sub_implsihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern21 ())
                {
                case 0:
                  return 137; /* sub_implsisiqi__z_z1_z2 */

                case 1:
                  return 139; /* sub_implsisihi__z_z1_z2 */

                case 2:
                  return 141; /* sub_implsisisi__z_z1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern24 (x3, E_QImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 98; /* sub_implqiqiqi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 106; /* sub_implqihiqi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 110; /* sub_implqisiqi__z_z1_noz2 */

            case E_HImode:
              if (pattern24 (x3, E_HImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 115; /* sub_implhiqihi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 120; /* sub_implhihihi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 127; /* sub_implhisihi__z_z1_noz2 */

            case E_SImode:
              if (pattern24 (x3, E_SImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 132; /* sub_implsiqisi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 136; /* sub_implsihisi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 142; /* sub_implsisisi__z_z1_noz2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern8 (x3))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 243; /* xor_implqiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 259; /* xor_implqiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 269; /* xor_implqiqisi__z_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 279; /* xor_implqihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 287; /* xor_implqihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 292; /* xor_implqihisi__z_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 299; /* xor_implqisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 307; /* xor_implqisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 312; /* xor_implqisisi__z_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 317; /* xor_implhiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 324; /* xor_implhiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 332; /* xor_implhiqisi__z_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 339; /* xor_implhihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 353; /* xor_implhihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 369; /* xor_implhihisi__z_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 377; /* xor_implhisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 384; /* xor_implhisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 392; /* xor_implhisisi__z_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 397; /* xor_implsiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 402; /* xor_implsiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 409; /* xor_implsiqisi__z_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 417; /* xor_implsihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 422; /* xor_implsihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 429; /* xor_implsihisi__z_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 439; /* xor_implsisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 449; /* xor_implsisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 463; /* xor_implsisisi__z_z1_z2 */

        case 9:
          return 244; /* xor_implqiqiqi__z_z1_noz2 */

        case 10:
          return 280; /* xor_implqihiqi__z_z1_noz2 */

        case 11:
          return 300; /* xor_implqisiqi__z_z1_noz2 */

        case 12:
          return 325; /* xor_implhiqihi__z_z1_noz2 */

        case 13:
          return 354; /* xor_implhihihi__z_z1_noz2 */

        case 14:
          return 385; /* xor_implhisihi__z_z1_noz2 */

        case 15:
          return 410; /* xor_implsiqisi__z_z1_noz2 */

        case 16:
          return 430; /* xor_implsihisi__z_z1_noz2 */

        case 17:
          return 464; /* xor_implsisisi__z_z1_noz2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern9 (x3, E_QImode) != 0)
                return -1;
              return 245; /* xor_implqiqiqi__noz_z1_z2 */

            case E_HImode:
              if (pattern9 (x3, E_HImode) != 0)
                return -1;
              return 355; /* xor_implhihihi__noz_z1_z2 */

            case E_SImode:
              if (pattern9 (x3, E_SImode) != 0)
                return -1;
              return 465; /* xor_implsisisi__noz_z1_z2 */

            case E_DImode:
              if (pattern9 (x3, E_DImode) != 0)
                return -1;
              return 578; /* pru_xordi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1 (x3))
            {
            case 0:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 246; /* xor_implqiqiqi__z_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 260; /* xor_implqiqihi__z_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 270; /* xor_implqiqisi__z_noz1_z2 */

            case 1:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 340; /* xor_implhihiqi__z_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 356; /* xor_implhihihi__z_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 370; /* xor_implhihisi__z_noz1_z2 */

            case 2:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 440; /* xor_implsisiqi__z_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 450; /* xor_implsisihi__z_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 466; /* xor_implsisisi__z_noz1_z2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode))
            return 1; /* prumovsi */
          break;

        case E_SQmode:
          if (nonimmediate_operand (operands[0], E_SQmode)
              && general_operand (operands[1], E_SQmode))
            return 2; /* prumovsq */
          break;

        case E_USQmode:
          if (nonimmediate_operand (operands[0], E_USQmode)
              && general_operand (operands[1], E_USQmode))
            return 3; /* prumovusq */
          break;

        case E_SAmode:
          if (nonimmediate_operand (operands[0], E_SAmode)
              && general_operand (operands[1], E_SAmode))
            return 4; /* prumovsa */
          break;

        case E_USAmode:
          if (nonimmediate_operand (operands[0], E_USAmode)
              && general_operand (operands[1], E_USAmode))
            return 5; /* prumovusa */
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[0], E_SFmode)
              && general_operand (operands[1], E_SFmode))
            return 6; /* prumovsf */
          break;

        case E_SDmode:
          if (nonimmediate_operand (operands[0], E_SDmode)
              && general_operand (operands[1], E_SDmode))
            return 7; /* prumovsd */
          break;

        case E_QImode:
          if (nonimmediate_operand (operands[0], E_QImode)
              && general_operand (operands[1], E_QImode))
            return 8; /* prumovqi */
          break;

        case E_QQmode:
          if (nonimmediate_operand (operands[0], E_QQmode)
              && general_operand (operands[1], E_QQmode))
            return 9; /* prumovqq */
          break;

        case E_UQQmode:
          if (nonimmediate_operand (operands[0], E_UQQmode)
              && general_operand (operands[1], E_UQQmode))
            return 10; /* prumovuqq */
          break;

        case E_HImode:
          if (nonimmediate_operand (operands[0], E_HImode)
              && general_operand (operands[1], E_HImode))
            return 11; /* prumovhi */
          break;

        case E_HQmode:
          if (nonimmediate_operand (operands[0], E_HQmode)
              && general_operand (operands[1], E_HQmode))
            return 12; /* prumovhq */
          break;

        case E_UHQmode:
          if (nonimmediate_operand (operands[0], E_UHQmode)
              && general_operand (operands[1], E_UHQmode))
            return 13; /* prumovuhq */
          break;

        case E_HAmode:
          if (nonimmediate_operand (operands[0], E_HAmode)
              && general_operand (operands[1], E_HAmode))
            return 14; /* prumovha */
          break;

        case E_UHAmode:
          if (nonimmediate_operand (operands[0], E_UHAmode)
              && general_operand (operands[1], E_UHAmode))
            return 15; /* prumovuha */
          break;

        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && general_operand (operands[1], E_DImode))
            return 16; /* movdi */
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[0], E_DFmode)
              && general_operand (operands[1], E_DFmode))
            return 17; /* movdf */
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[0], E_DDmode)
              && general_operand (operands[1], E_DDmode))
            return 18; /* movdd */
          break;

        case E_DQmode:
          if (nonimmediate_operand (operands[0], E_DQmode)
              && general_operand (operands[1], E_DQmode))
            return 19; /* movdq */
          break;

        case E_UDQmode:
          if (nonimmediate_operand (operands[0], E_UDQmode)
              && general_operand (operands[1], E_UDQmode))
            return 20; /* movudq */
          break;

        default:
          break;
        }
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (register_operand (operands[0], E_SImode))
        return 584; /* indirect_jump */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LABEL_REF
      || GET_CODE (x2) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  return 585; /* jump */
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (shift_operand (operands[2], E_QImode))
        return 475; /* ashl_implqiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 483; /* ashl_implqiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 487; /* ashl_implqiqisi__z_z1_z2 */

    case 1:
      if (shift_operand (operands[2], E_QImode))
        return 491; /* ashl_implqihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 495; /* ashl_implqihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 497; /* ashl_implqihisi__z_z1_z2 */

    case 2:
      if (shift_operand (operands[2], E_QImode))
        return 499; /* ashl_implqisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 503; /* ashl_implqisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 505; /* ashl_implqisisi__z_z1_z2 */

    case 3:
      if (shift_operand (operands[2], E_QImode))
        return 507; /* ashl_implhiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 509; /* ashl_implhiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 513; /* ashl_implhiqisi__z_z1_z2 */

    case 4:
      if (shift_operand (operands[2], E_QImode))
        return 515; /* ashl_implhihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 519; /* ashl_implhihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 527; /* ashl_implhihisi__z_z1_z2 */

    case 5:
      if (shift_operand (operands[2], E_QImode))
        return 531; /* ashl_implhisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 533; /* ashl_implhisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 537; /* ashl_implhisisi__z_z1_z2 */

    case 6:
      if (shift_operand (operands[2], E_QImode))
        return 539; /* ashl_implsiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 541; /* ashl_implsiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 543; /* ashl_implsiqisi__z_z1_z2 */

    case 7:
      if (shift_operand (operands[2], E_QImode))
        return 547; /* ashl_implsihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 549; /* ashl_implsihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 551; /* ashl_implsihisi__z_z1_z2 */

    case 8:
      if (shift_operand (operands[2], E_QImode))
        return 555; /* ashl_implsisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 559; /* ashl_implsisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 563; /* ashl_implsisisi__z_z1_z2 */

    case 9:
      return 476; /* ashl_implqiqiqi__z_z1_noz2 */

    case 10:
      return 492; /* ashl_implqihiqi__z_z1_noz2 */

    case 11:
      return 500; /* ashl_implqisiqi__z_z1_noz2 */

    case 12:
      return 510; /* ashl_implhiqihi__z_z1_noz2 */

    case 13:
      return 520; /* ashl_implhihihi__z_z1_noz2 */

    case 14:
      return 534; /* ashl_implhisihi__z_z1_noz2 */

    case 15:
      return 544; /* ashl_implsiqisi__z_z1_noz2 */

    case 16:
      return 552; /* ashl_implsihisi__z_z1_noz2 */

    case 17:
      return 564; /* ashl_implsisisi__z_z1_noz2 */

    case 18:
      return 477; /* ashl_implqiqiqi__noz_z1_z2 */

    case 19:
      return 521; /* ashl_implhihihi__noz_z1_z2 */

    case 20:
      return 565; /* ashl_implsisisi__noz_z1_z2 */

    case 21:
      if (shift_operand (operands[2], E_QImode))
        return 478; /* ashl_implqiqiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 484; /* ashl_implqiqihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 488; /* ashl_implqiqisi__z_noz1_z2 */

    case 22:
      if (shift_operand (operands[2], E_QImode))
        return 516; /* ashl_implhihiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 522; /* ashl_implhihihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 528; /* ashl_implhihisi__z_noz1_z2 */

    case 23:
      if (shift_operand (operands[2], E_QImode))
        return 556; /* ashl_implsisiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 560; /* ashl_implsisihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 566; /* ashl_implsisisi__z_noz1_z2 */

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_8 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          switch (pattern15 (x2, E_QImode))
            {
            case 0:
              return 23; /* *zero_extendqiqi2 */

            case 1:
              return 24; /* *zero_extendhiqi2 */

            case 2:
              return 25; /* *zero_extendsiqi2 */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern15 (x2, E_HImode))
            {
            case 0:
              return 26; /* *zero_extendqihi2 */

            case 1:
              return 27; /* *zero_extendhihi2 */

            case 2:
              return 28; /* *zero_extendsihi2 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern15 (x2, E_SImode))
            {
            case 0:
              return 29; /* *zero_extendqisi2 */

            case 1:
              return 30; /* *zero_extendhisi2 */

            case 2:
              return 31; /* *zero_extendsisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern15 (x2, E_DImode))
            {
            case 0:
              return 32; /* zero_extendqidi2 */

            case 1:
              return 33; /* zero_extendhidi2 */

            case 2:
              return 34; /* zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern17 (x2, E_QImode) != 0)
            return -1;
          return 35; /* extzvqi */

        case E_HImode:
          if (pattern17 (x2, E_HImode) != 0)
            return -1;
          return 36; /* extzvhi */

        case E_SImode:
          if (pattern17 (x2, E_SImode) != 0)
            return -1;
          return 37; /* extzvsi */

        default:
          return -1;
        }

    case PLUS:
      return recog_5 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_6 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_3 (x1, insn, pnum_clobbers);

    case AND:
      return recog_4 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_1_operand (operands[2], E_QImode))
        return -1;
      switch (pattern16 (x2))
        {
        case 0:
          return 46; /* ashrqi3_single */

        case 1:
          return 47; /* ashrhi3_single */

        case 2:
          return 48; /* ashrsi3_single */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern3 (x2, E_QImode))
                {
                case 0:
                  return 187; /* neg_implqiqi__z */

                case 1:
                  return 189; /* neg_implqihi__z */

                case 2:
                  return 190; /* neg_implqisi__z */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern3 (x2, E_HImode))
                {
                case 0:
                  return 191; /* neg_implhiqi__z */

                case 1:
                  return 192; /* neg_implhihi__z */

                case 2:
                  return 194; /* neg_implhisi__z */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern3 (x2, E_SImode))
                {
                case 0:
                  return 195; /* neg_implsiqi__z */

                case 1:
                  return 196; /* neg_implsihi__z */

                case 2:
                  return 197; /* neg_implsisi__z */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern16 (x2))
            {
            case 0:
              return 188; /* neg_implqiqi__noz */

            case 1:
              return 193; /* neg_implhihi__noz */

            case 2:
              return 198; /* neg_implsisi__noz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern3 (x2, E_QImode))
                {
                case 0:
                  return 199; /* one_cmpl_implqiqi__z */

                case 1:
                  return 201; /* one_cmpl_implqihi__z */

                case 2:
                  return 202; /* one_cmpl_implqisi__z */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern3 (x2, E_HImode))
                {
                case 0:
                  return 203; /* one_cmpl_implhiqi__z */

                case 1:
                  return 204; /* one_cmpl_implhihi__z */

                case 2:
                  return 206; /* one_cmpl_implhisi__z */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern3 (x2, E_SImode))
                {
                case 0:
                  return 207; /* one_cmpl_implsiqi__z */

                case 1:
                  return 208; /* one_cmpl_implsihi__z */

                case 2:
                  return 209; /* one_cmpl_implsisi__z */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 200; /* one_cmpl_implqiqi__noz */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 205; /* one_cmpl_implhihi__noz */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 210; /* one_cmpl_implsisi__noz */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 579; /* one_cmpldi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_7 (x1, insn, pnum_clobbers);

    case UMIN:
      switch (pattern10 (x1))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 247; /* umin_implqiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 261; /* umin_implqiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 271; /* umin_implqiqisi__z_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 281; /* umin_implqihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 288; /* umin_implqihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 293; /* umin_implqihisi__z_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 301; /* umin_implqisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 308; /* umin_implqisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 313; /* umin_implqisisi__z_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 318; /* umin_implhiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 326; /* umin_implhiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 333; /* umin_implhiqisi__z_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 341; /* umin_implhihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 357; /* umin_implhihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 371; /* umin_implhihisi__z_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 378; /* umin_implhisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 386; /* umin_implhisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 393; /* umin_implhisisi__z_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 398; /* umin_implsiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 403; /* umin_implsiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 411; /* umin_implsiqisi__z_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 418; /* umin_implsihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 423; /* umin_implsihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 431; /* umin_implsihisi__z_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 441; /* umin_implsisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 451; /* umin_implsisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 467; /* umin_implsisisi__z_z1_z2 */

        case 9:
          return 248; /* umin_implqiqiqi__z_z1_noz2 */

        case 10:
          return 282; /* umin_implqihiqi__z_z1_noz2 */

        case 11:
          return 302; /* umin_implqisiqi__z_z1_noz2 */

        case 12:
          return 327; /* umin_implhiqihi__z_z1_noz2 */

        case 13:
          return 358; /* umin_implhihihi__z_z1_noz2 */

        case 14:
          return 387; /* umin_implhisihi__z_z1_noz2 */

        case 15:
          return 412; /* umin_implsiqisi__z_z1_noz2 */

        case 16:
          return 432; /* umin_implsihisi__z_z1_noz2 */

        case 17:
          return 468; /* umin_implsisisi__z_z1_noz2 */

        case 18:
          return 249; /* umin_implqiqiqi__noz_z1_z2 */

        case 19:
          return 359; /* umin_implhihihi__noz_z1_z2 */

        case 20:
          return 469; /* umin_implsisisi__noz_z1_z2 */

        case 21:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 250; /* umin_implqiqiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 262; /* umin_implqiqihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 272; /* umin_implqiqisi__z_noz1_z2 */

        case 22:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 342; /* umin_implhihiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 360; /* umin_implhihihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 372; /* umin_implhihisi__z_noz1_z2 */

        case 23:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 442; /* umin_implsisiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 452; /* umin_implsisihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 470; /* umin_implsisisi__z_noz1_z2 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern10 (x1))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 251; /* umax_implqiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 263; /* umax_implqiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 273; /* umax_implqiqisi__z_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 283; /* umax_implqihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 289; /* umax_implqihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 294; /* umax_implqihisi__z_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 303; /* umax_implqisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 309; /* umax_implqisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 314; /* umax_implqisisi__z_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 319; /* umax_implhiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 328; /* umax_implhiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 334; /* umax_implhiqisi__z_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 343; /* umax_implhihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 361; /* umax_implhihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 373; /* umax_implhihisi__z_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 379; /* umax_implhisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 388; /* umax_implhisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 394; /* umax_implhisisi__z_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 399; /* umax_implsiqiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 404; /* umax_implsiqihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 413; /* umax_implsiqisi__z_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 419; /* umax_implsihiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 424; /* umax_implsihihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 433; /* umax_implsihisi__z_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 443; /* umax_implsisiqi__z_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 453; /* umax_implsisihi__z_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 471; /* umax_implsisisi__z_z1_z2 */

        case 9:
          return 252; /* umax_implqiqiqi__z_z1_noz2 */

        case 10:
          return 284; /* umax_implqihiqi__z_z1_noz2 */

        case 11:
          return 304; /* umax_implqisiqi__z_z1_noz2 */

        case 12:
          return 329; /* umax_implhiqihi__z_z1_noz2 */

        case 13:
          return 362; /* umax_implhihihi__z_z1_noz2 */

        case 14:
          return 389; /* umax_implhisihi__z_z1_noz2 */

        case 15:
          return 414; /* umax_implsiqisi__z_z1_noz2 */

        case 16:
          return 434; /* umax_implsihisi__z_z1_noz2 */

        case 17:
          return 472; /* umax_implsisisi__z_z1_noz2 */

        case 18:
          return 253; /* umax_implqiqiqi__noz_z1_z2 */

        case 19:
          return 363; /* umax_implhihihi__noz_z1_z2 */

        case 20:
          return 473; /* umax_implsisisi__noz_z1_z2 */

        case 21:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 254; /* umax_implqiqiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 264; /* umax_implqiqihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 274; /* umax_implqiqisi__z_noz1_z2 */

        case 22:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 344; /* umax_implhihiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 364; /* umax_implhihihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 374; /* umax_implhihisi__z_noz1_z2 */

        case 23:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 444; /* umax_implsisiqi__z_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 454; /* umax_implsisihi__z_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 474; /* umax_implsisisi__z_noz1_z2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_9 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      switch (pattern13 (x1))
        {
        case 0:
          if (shift_operand (operands[2], E_QImode))
            return 479; /* lshr_implqiqiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 485; /* lshr_implqiqihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 489; /* lshr_implqiqisi__z_z1_z2 */

        case 1:
          if (shift_operand (operands[2], E_QImode))
            return 493; /* lshr_implqihiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 496; /* lshr_implqihihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 498; /* lshr_implqihisi__z_z1_z2 */

        case 2:
          if (shift_operand (operands[2], E_QImode))
            return 501; /* lshr_implqisiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 504; /* lshr_implqisihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 506; /* lshr_implqisisi__z_z1_z2 */

        case 3:
          if (shift_operand (operands[2], E_QImode))
            return 508; /* lshr_implhiqiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 511; /* lshr_implhiqihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 514; /* lshr_implhiqisi__z_z1_z2 */

        case 4:
          if (shift_operand (operands[2], E_QImode))
            return 517; /* lshr_implhihiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 523; /* lshr_implhihihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 529; /* lshr_implhihisi__z_z1_z2 */

        case 5:
          if (shift_operand (operands[2], E_QImode))
            return 532; /* lshr_implhisiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 535; /* lshr_implhisihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 538; /* lshr_implhisisi__z_z1_z2 */

        case 6:
          if (shift_operand (operands[2], E_QImode))
            return 540; /* lshr_implsiqiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 542; /* lshr_implsiqihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 545; /* lshr_implsiqisi__z_z1_z2 */

        case 7:
          if (shift_operand (operands[2], E_QImode))
            return 548; /* lshr_implsihiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 550; /* lshr_implsihihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 553; /* lshr_implsihisi__z_z1_z2 */

        case 8:
          if (shift_operand (operands[2], E_QImode))
            return 557; /* lshr_implsisiqi__z_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 561; /* lshr_implsisihi__z_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 567; /* lshr_implsisisi__z_z1_z2 */

        case 9:
          return 480; /* lshr_implqiqiqi__z_z1_noz2 */

        case 10:
          return 494; /* lshr_implqihiqi__z_z1_noz2 */

        case 11:
          return 502; /* lshr_implqisiqi__z_z1_noz2 */

        case 12:
          return 512; /* lshr_implhiqihi__z_z1_noz2 */

        case 13:
          return 524; /* lshr_implhihihi__z_z1_noz2 */

        case 14:
          return 536; /* lshr_implhisihi__z_z1_noz2 */

        case 15:
          return 546; /* lshr_implsiqisi__z_z1_noz2 */

        case 16:
          return 554; /* lshr_implsihisi__z_z1_noz2 */

        case 17:
          return 568; /* lshr_implsisisi__z_z1_noz2 */

        case 18:
          return 481; /* lshr_implqiqiqi__noz_z1_z2 */

        case 19:
          return 525; /* lshr_implhihihi__noz_z1_z2 */

        case 20:
          return 569; /* lshr_implsisisi__noz_z1_z2 */

        case 21:
          if (shift_operand (operands[2], E_QImode))
            return 482; /* lshr_implqiqiqi__z_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 486; /* lshr_implqiqihi__z_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 490; /* lshr_implqiqisi__z_noz1_z2 */

        case 22:
          if (shift_operand (operands[2], E_QImode))
            return 518; /* lshr_implhihiqi__z_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 526; /* lshr_implhihihi__z_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 530; /* lshr_implhihisi__z_noz1_z2 */

        case 23:
          if (shift_operand (operands[2], E_QImode))
            return 558; /* lshr_implsisiqi__z_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 562; /* lshr_implsisihi__z_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 570; /* lshr_implsisisi__z_noz1_z2 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          switch (XINT (x2, 1))
            {
            case 9:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x8 = XVECEXP (x2, 0, 0);
              operands[1] = x8;
              if (!regio_operand (operands[1], E_SImode))
                return -1;
              return 571; /* *regio_readsi */

            case 10:
              if (!regio_operand (operands[0], E_SImode))
                return -1;
              x8 = XVECEXP (x2, 0, 0);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  return 572; /* *regio_nozext_writesi */

                case ZERO_EXTEND:
                  if (GET_MODE (x8) != E_SImode)
                    return -1;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  switch (pattern27 ())
                    {
                    case 0:
                      return 573; /* *regio_zext_write_r30qi */

                    case 1:
                      return 574; /* *regio_zext_write_r30hi */

                    case 2:
                      return 575; /* *regio_zext_write_r30si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 5)
            return -1;
          x8 = XVECEXP (x2, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x2, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !reg_or_ubyte_operand (operands[1], E_HImode))
                return -1;
              return 657; /* doloop_begin_internalhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 658; /* doloop_begin_internalsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!pru_muldst_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!pru_mulsrc0_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!pru_mulsrc1_operand (operands[2], E_SImode))
        return -1;
      return 580; /* mulsi3 */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!call_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      *pnum_clobbers = 1;
      return 587; /* *call_value */

    case IF_THEN_ELSE:
      return recog_1 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_10 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 0);
              operands[1] = x3;
              if (register_operand (operands[1], E_QImode)
                  && load_multiple_operation (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (memory_operand (operands[2], E_QImode)
                      && 
#line 338 "../../gcc/config/pru/pru.md"
(reload_completed))
                    return 21; /* *pru_load_multiple */
                }
              if (memory_operand (operands[1], E_QImode)
                  && store_multiple_operation (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (register_operand (operands[2], E_QImode)
                      && 
#line 396 "../../gcc/config/pru/pru.md"
(reload_completed))
                    return 22; /* *pru_store_multiple */
                }
            }
        }
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!call_operand (operands[0], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              x6 = XVECEXP (x1, 0, 1);
              switch (pattern26 (x6))
                {
                case 0:
                  return 586; /* *call */

                case 1:
                  if (!
#line 1171 "../../gcc/config/pru/pru.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 588; /* *sibcall */

                default:
                  return -1;
                }

            case SET:
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case CALL:
                  x7 = XEXP (x4, 0);
                  if (GET_CODE (x7) != MEM
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x3 = XEXP (x2, 0);
                  operands[0] = x3;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!call_operand (operands[1], E_SImode))
                    return -1;
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (pattern26 (x6))
                    {
                    case 0:
                      return 587; /* *call_value */

                    case 1:
                      if (!register_operand (operands[0], E_VOIDmode)
                          || !
#line 1182 "../../gcc/config/pru/pru.md"
(SIBLING_CALL_P (insn)))
                        return -1;
                      return 589; /* *sibcall_value */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x4;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 0);
                  if (GET_CODE (x3) != PC)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != USE)
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (GET_CODE (x10) != LABEL_REF)
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[1] = x11;
                  return 590; /* *tablejump */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              switch (XINT (x2, 1))
                {
                case 2:
                  if (!const_uhword_operand (operands[0], E_SImode))
                    return -1;
                  return 666; /* delay_cycles_2x_plus1_hi */

                case 3:
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  return 667; /* delay_cycles_2x_plus2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          if (pattern14 (x1) != 0)
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 1);
          x7 = XEXP (x4, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          x14 = XEXP (x9, 0);
          operands[1] = x14;
          x15 = XVECEXP (x1, 0, 2);
          x16 = XVECEXP (x15, 0, 0);
          operands[2] = x16;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x17 = XEXP (x13, 0);
          operands[3] = x17;
          x6 = XVECEXP (x1, 0, 1);
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          x10 = XEXP (x6, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x18) != E_HImode
                  || !scratch_operand (operands[3], E_HImode))
                return -1;
              return 659; /* doloop_end_internalhi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x18) != E_SImode
                  || !scratch_operand (operands[3], E_SImode))
                return -1;
              return 660; /* doloop_end_internalsi */

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL
              || pattern14 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 1);
          x7 = XEXP (x4, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          x14 = XEXP (x9, 0);
          operands[1] = x14;
          x15 = XVECEXP (x1, 0, 2);
          x16 = XVECEXP (x15, 0, 0);
          operands[2] = x16;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          x10 = XEXP (x6, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x18) != E_HImode)
                return -1;
              *pnum_clobbers = 1;
              return 659; /* doloop_end_internalhi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x18) != E_SImode)
                return -1;
              *pnum_clobbers = 1;
              return 660; /* doloop_end_internalsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      if (
#line 1081 "../../gcc/config/pru/pru.md"
(pru_can_use_return_insn ()))
        return 581; /* return */
      return 582; /* simple_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 8:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 583; /* blockage */

        case 0:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_VOIDmode))
            return -1;
          return 664; /* delay_cycles_start */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_VOIDmode))
            return -1;
          return 665; /* delay_cycles_end */

        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_uhword_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 666; /* delay_cycles_2x_plus1_hi */

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 667; /* delay_cycles_2x_plus2_si */

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 668; /* delay_cycles_1 */

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 671; /* pru_halt */

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x20 = XEXP (x1, 0);
      if (GET_CODE (x20) != MEM
          || GET_MODE (x20) != E_SImode)
        return -1;
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!call_operand (operands[0], E_SImode))
        return -1;
      x22 = XEXP (x1, 1);
      operands[1] = x22;
      *pnum_clobbers = 1;
      return 586; /* *call */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 6)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 663; /* pruloop_end */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 669; /* nop */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
